//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Sun Apr 20 21:00:17 GMT-0800 1997
// Last Modified: Sun Apr 20 21:00:20 GMT-0800 1997
// Filename:      .../sig/src/Filter/Allpass/Allpass.h
// Syntax:        C++ 
// $Smake:        cc -Wall -g -c %b.cc -I../../../include && rm -f %b.o
//

#ifndef _ALLPASS_H_INCLUDED
#define _ALLPASS_H_INCLUDED

#include "Filter.h"
#include "Delay.h"


class Allpass : public Filter {
   public:
                         Allpass        (void);
                        ~Allpass        ();
      void               action         (void);
      sampleType         getDelay       (void);
      sampleType         getLoopTime    (void);
      sampleType         getMaxDelay    (void);
      sampleType         getGain        (void);
      sampleType         getSignal      (void);
      sampleType         output         (int index);
      void               setDelay       (sampleType aDelay);
      void               setLoopTime    (sampleType aLoopTime);
      void               setMaxDelay    (long aMax);
      void               setReverbTime  (sampleType aReverbTime);
      void               setGain        (sampleType aGain);
 
   protected:
      sampleType         outputValue;
      Delay              delayline;
};


#endif  _ALLPASS_H_INCLUDED


