//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Sun Apr 20 19:02:37 GMT-0800 1997
// Last Modified: Sun Apr 20 19:02:40 GMT-0800 1997
// Filename:      .../sig/src/Filter/Comb/Comb.h
// Syntax:        C++ 
// $Smake:        cc -Wall -g -c %b.cc -I../../../include && rm -f %b.o
//

#ifndef _COMB_H_INCLUDED
#define _COMB_H_INCLUDED

#include "Filter.h"
#include "Delay.h"

class Comb : public Filter {
   public:
                         Comb           (void);
                        ~Comb           ();
      void               action         (void);
      sampleType         getDelay       (void);
      sampleType         getMinFund     (void);
      sampleType         getScale       (void);
      sampleType         getSignal      (void);
      sampleType         output         (int index);
      void               setDelay       (sampleType aDelay);
      void               setFund        (sampleType aFund);
      void               setLoopTime    (sampleType aLoopTime);
      void               setMinFund     (sampleType aMin);
      void               setReverbTime  (sampleType aReverbTime);
      void               setScale       (sampleType aScale);
 
   protected:
      sampleType         outputValue;
      Delay              delayline;
};


#endif  _COMB_H_INCLUDED

