//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Sat Nov  2 10:36:12 PST 1996
// Last Modified: Sat Nov  2 10:36:18 PST 1996
// Filename:      .../sig/src/misc/Definitions.h
// Syntax:        C++ 
// $Smake:        g++ -O -o %b %f && strip %b
//

#ifndef _DEFINITIONS_H_INCLUDED
#define _DEFINITIONS_H_INCLUDED

typedef double sampleType;

typedef unsigned char   uchar;
typedef unsigned int    uint;
typedef unsigned short ushort;
typedef unsigned long   ulong;

class xSoundHeader {
   public:
      uint magic;
      uint dataOffset;
      uint dataSize;
      uint dataFormat;
      uint srate;
      uint channels;
      uchar* info;
};

#define NONE                 ((long)0xffffffff)
#define TRUE                 (1)
#define FALSE                (0)

#define GENERATOR            (1)
#define FILTER               (2)

#ifndef PI
   #define PI                (3.14159265358979323846264338328)
#endif
#define TWOPI                (6.2831853)
#define HALFPI               (1.5707963)
#define SND_FORMAT_LINEAR_16 (3)


#endif  _DEFINITIONS_H_INCLUDED

