//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Sat Nov  2 23:39:21 PST 1996
// Last Modified: Wed Nov 13 23:22:27 PST 1996
// Filename:      /Users/craig/lang/c/sig/src/misc/Dependencies.h
// Syntax:        C++ (Gnu C++ Complier: /Local/Unix/bin/g++)
//

#ifndef _DEPENDENCIES_H_INCLUDED
#define _DEPENDENCIES_H_INCLUDED

#include "Definitions.h"
#include "HelperFunctions.h"

// Abstract Classes:
#include "Signal.h"
#include "Generator.h"
#include "Filter.h"

// Generators:
#include "Constant.h"
#include "Envelope.h"
#include "FixedSine.h"
#include "Function.h"
#include "Impulse.h"
#include "SoundFileIn.h"
#include "UserIn.h"
#include "WhiteNoise.h"

// Filters:
#include "Add.h"
#include "Allpass.h"
#include "Allpass1.h"
#include "Comb.h"
#include "Delayline.h"
#include "Empty.h"
#include "Downsample.h"
#include "Multiply.h"
#include "OnePole.h"
#include "Osc.h"
#include "Pan.h"
#include "Pan2.h"
#include "RandomDist.h"
#include "Resonator.h"
#include "Reverberator.h"
#include "Reverb.h"
#include "ReverbA.h"
#include "Scale.h"
#include "Selector.h"
#include "SoundFileOut.h"
#include "Switch.h"
#include "UnitDelay.h"
#include "UserOut.h"
// #include "WaveTable.h"


// Other classes:
#include "Action.h"
#include "SoundHeader.h"
#include "ComplexD.h"

// Computer Specific classes:
#ifdef LINUX
   #include "LinuxSoundOut.h"
#endif


#endif  _DEPENDENCIES_H_INCLUDED
