// convert lines from a Diagram document into sinusoids.
//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Wed Jun 25 15:33:07 GMT-0800 1997
// Last Modified: Mon Jun 30 10:38:36 GMT-0800 1997
// Filename:      .../sig/examples/line2sine/OscParameter.h
// Syntax:        C++
// $Smake:        cc -Wall -g -c %b.cc -I../../include && rm -f %b.o
//


#ifndef _OSCPARAMETER_H_INCLUDED
#define _OSCPARAMETER_H_INCLUDED

#include "Vertex.h"
#include "Collection.h"


class OscParameter {
   public:
                    OscParameter     (void);
                    OscParameter     (OscParameter& another);
                   ~OscParameter     ();
 
      double        getAmp           (void);
      const char*   getAmpEnv        (void);
      const char*   getFreqEnv       (void);
      long          getStart         (void);
      long          getEnd           (void);
      long          getDuration      (void);
      OscParameter& operator=        (OscParameter& another);
      void          print            (void);
      void          setAmp           (double anAmp);
      void          setAmpEnv        (const char* aString);
      void          setFreqEnv       (const char* aString);
      void          setStart         (long aStart);
      void          setEnd           (long anEnd);
      
      static char defaultAmpEnv[10000];

   protected:
      double        amp;
      long          start;
      long          end;
      char*         freqString;
      char*         ampString;

};



class OscParameters {
   public:
      OscParameters(void);  
  
      Collection<OscParameter> data;
      Collection<doubleXY>     start;
      Collection<doubleXY>     end;

      void print(void);
      void sort(void);
};

int xyComp(const void* c1, const void* c2);




#endif  _OSCPARAMETER_H_INCLUDED




